<?php

class Authentication extends DBfunctions
{
	// Get the settings from the database and put them into session variables
	function getSettings()
	{
		$_SESSION['authSettingsArray'] = $this->getrow($this->query("SELECT * FROM ".ROSTER_ADDON_AUTHENTICATIONSETTINGSTABLE.""));
		@extract($_SESSION['authSettingsArray']);
			$_SESSION['profileField'] = $profile_field;
			$_SESSION['forumDBprefix'] = $cms_table_prefix;
			$_SESSION['authMessages'] = $auth_messages;
			$_SESSION['separateDB'] = $separate_db;
			$_SESSION['upload_group'] = $opt_upload_group;
			$_SESSION['upload_members_group'] = $opt_upload_members_group;
			$_SESSION['prog_id'] = $opt_prog_id;
			$_SESSION['opt_cookie_prefix'] = $opt_cookie_prefix;
			$_SESSION['cms_name'] = $cms_name;
	}
	
	
	
	function detectCMS()
	{
		if($_COOKIE['RosterUserName'])
		{
			$_SESSION['UserName'] = $_COOKIE['RosterUserName'];
		}else{
			global $IDNames;
			foreach($IDNames as $key => $value){
				if($key == $_SESSION['cms_name']){
					$this->authenticateUser($key);
					return;
				}
			}
		}
	}
	
	
	function current_dir() 
	{ 
	$path = dirname($_SERVER[PHP_SELF]); 
	$position = strrpos($path,'/') + 1; 
	return substr($path,$position); 
	} 
		
	
	function deleteCookie()
	{
		setcookie("RosterUserName", "", time() - 3600);
	}
	
	
	// Compare the passed in name against the names on the roster
	function checkRoster($name)
	{
		global $db_prefix;
		$authArray = $this->getrow($this->query("SELECT ".$db_prefix."members.name FROM ".$db_prefix."members WHERE ".$db_prefix."members.name = '".$this->escape(ucfirst(strtolower($name)))."'"));
		if($authArray)
		{
			$GLOBALS['rosterUserName'] = $authArray['name'];
			setcookie("RosterUserName", ucfirst(strtolower($authArray['name'])));
			return true;
		}
	}
	
	
	function authenticateUser($CMStype)
	{
		switch ($CMStype)
		{
			case "e107_6":
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype; 
				$GLOBALS['authenticated_user'] = true;	
				if(defined(USERNAME))
				{
					/*-Debugger-*/ $errors['User ID']['Name'] = USERNAME;
					if(!$this->checkRoster(USERNAME))
					{
						$authArray = $this->getrow($this->query("SELECT user_customtitle, user_icq, user_aim, user_yim, user_msn, user_login FROM ".$_SESSION['forumDBprefix']."user WHERE user_name = '".USERNAME."'", $_SESSION['separateDB']));
						/*-Debugger-*/ $errors['User ID']['Query'] = "SELECT user_customtitle, user_icq, user_aim, user_yim, user_msn, user_login FROM ".$_SESSION['forumDBprefix']."user WHERE user_name = '".USERNAME."'";
						if($authArray)
						{
							foreach($authArray as $field => $name){
								/*-Debugger-*/ $errors['Character Name'][$field] = $name;
								if(!empty($name)) $this->checkRoster($name);
							}
						}
					}
				}else{ 
					if(isset($_REQUEST['ecookie'])) {
						$cookie = $_REQUEST['ecookie'];
					}elseif(isset($_REQUEST['e107cookie'])){
						$cookie = $_REQUEST['e107cookie'];
					} 
					$euser = explode(".", $cookie, 2);
					/*-Debugger-*/ if($euser[0]>0) $errors['User ID']['ID'] = $euser[0];
					/*-Debugger-*/ else $errors['User ID']['ID'] = '<b>User ID could not be established</b>';
					if($euser[0]){
						$authArray = $this->getrow($this->query("SELECT user_name, user_customtitle, user_icq, user_aim, user_yim, user_msn, user_login FROM  ".$_SESSION['forumDBprefix']."user WHERE user.user_id = ".$euser[0]."", $_SESSION['separateDB'])); 
						/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT user_name, user_customtitle, user_icq, user_aim, user_yim, user_msn, user_login FROM  ".$_SESSION['forumDBprefix']."user WHERE  user_id = ".$euser[0]."";
						if($authArray){
							foreach($authArray as $field => $name){
								/*-Debugger-*/ $errors['Character Name'][$field] = $name;
								if(!empty($name)) $this->checkRoster($name);
							}
						}
					}
				}# $userName = USERNAME;
				break;
			}
			case "e107_7":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype; 
				$GLOBALS['authenticated_user'] = true;	
				// The user ID seems to be the first number in this sort of cookie string: 1.696d29e0940a4957748fe3fc9efd22a3
				$e107userID = explode(".", $_REQUEST[$_SESSION['opt_cookie_prefix']]);
				// $e107userID[0] contains the user id
				/*-Debugger-*/ if($e107userID[0]>0) $errors['userID']['status'] = 'UserID query appears to be OK';
				/*-Debugger-*/ else $errors['User ID']['Status'] = '<b>UserID query appears to be broken</b>';
				/*-Debugger-*/ if(!@in_array($_SESSION['opt_cookie_prefix'], $_REQUEST)) $errors['User ID']['Cause'] = '<b>Check the cookie prefix</b>';
				/*-Debugger-*/ if($e107userID[0]>0)$errors['User ID']['ID'] = $e107userID[0];
				/*-Debugger-*/ $errors['User ID']['Full cookie name'] = $_SESSION['opt_cookie_prefix'];
				
				$authArray = $this->getrow($this->query("SELECT  ".$_SESSION['forumDBprefix']."user.user_name, ".$_SESSION['forumDBprefix']."user.user_loginname, ".$_SESSION['forumDBprefix']."user.user_customtitle, ".$_SESSION['forumDBprefix']."user_extended.user_".$_SESSION['profileField']." FROM  ".$_SESSION['forumDBprefix']."user LEFT JOIN ".$_SESSION['forumDBprefix']."user_extended ON ".$_SESSION['forumDBprefix']."user_extended.user_extended_id = ".intval($e107userID[0])." WHERE ".$_SESSION['forumDBprefix']."user.user_id = ".intval($e107userID[0])."", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT  ".$_SESSION['forumDBprefix']."user.user_name, ".$_SESSION['forumDBprefix']."user.user_loginname, ".$_SESSION['forumDBprefix']."user.user_customtitle, ".$_SESSION['forumDBprefix']."user_extended.user_".$_SESSION['profileField']." FROM  ".$_SESSION['forumDBprefix']."user LEFT JOIN ".$_SESSION['forumDBprefix']."user_extended ON ".$_SESSION['forumDBprefix']."user_extended.user_extended_id = ".intval($e107userID[0])." WHERE ".$_SESSION['forumDBprefix']."user.user_id = ".intval($e107userID[0])."";
				if($authArray){
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "phpBB":
			{
				/*-Debugger-*/	$errors['CMS']['Type'] = $CMStype; 
				
				// peel the userID out of the weird cookie makeup
				// normal:
				# $phpBBuserID = explode(":", $_REQUEST[$_SESSION['opt_cookie_prefix'].'_data']);
				# $phpBBuserID = explode('"', stripslashes($phpBBuserID[10]));
				// odd:
				# $phpBBuserID = explode("|", $_REQUEST['phpbb2mysql_data']);
				# $phpBBuserID = explode("=", $phpBBuserID[1]);
				// now the userID is in $phpBBuserID[1];
				// how about using the session id instead
				$phpBBuserID = $this->getrow($this->query("SELECT session_user_id AS id FROM ".$_SESSION['forumDBprefix']."sessions WHERE session_id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'_sid']."'", $_SESSION['separateDB']));
				/*-Debugger-*/ if($phpBBuserID['id']>0) $errors['userID']['status'] = 'UserID query appears to be OK';
				/*-Debugger-*/ else $errors['User ID']['Status'] = '<b>UserID query appears to be broken</b>';
				/*-Debugger-*/ if(!@in_array($_SESSION['opt_cookie_prefix'].'_sid', $_REQUEST)) $errors['User ID']['Cause'] = '<b>Check the cookie prefix</b>';
				/*-Debugger-*/ $errors['User ID']['Query'] = "SELECT session_user_id AS id FROM ".$_SESSION['forumDBprefix']."sessions WHERE session_id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'_sid']."'";
				/*-Debugger-*/ $errors['User ID']['Full cookie name'] = $_SESSION['opt_cookie_prefix'].'_sid';
				/*-Debugger-*/ $errors['User ID']['Cookie prefix'] = $_SESSION['opt_cookie_prefix'];
				/*-Debugger-*/ if(!empty($_REQUEST[$_SESSION['opt_cookie_prefix'].'_sid'])) $errors['User ID']['Cookie content'] = $_REQUEST[$_SESSION['opt_cookie_prefix'].'_sid'];
				/*-Debugger-*/ if($phpBBuserID['id']>0) $errors['User ID']['ID'] = $phpBBuserID['id'];

				
				// if you're not logged in, there's not gonna be a userID, so dont bother with the rest
				if(empty($phpBBuserID['id'])) break;
				// check if the wow characters mod for phpbb is installed, if not check the username and extra fields for a char name
				if($this->getCount($this->query("SHOW TABLES LIKE '".$_SESSION['forumDBprefix']."characters'"))==1){ 
					/*-Debugger-*/ $errors['phpBB WoW Char Mod']['Status'] = 'Installed';
					$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."characters.name FROM ".$_SESSION['forumDBprefix']."characters WHERE ".$_SESSION['forumDBprefix']."characters.user_ID = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
					if($authArray) {
						/*-Debugger-*/ $errors['phpBB WoW Char Mod']['Name'] = $authArray['name'];
						if(!$this->checkRoster($authArray['name'])) { 
							$authArray = $this->getrow($this->query("SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
							/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."";
							foreach($authArray as $field => $name){
								/*-Debugger-*/ $errors['Character Name'][$field] = $name;
								if(!empty($name)) $this->checkRoster($name);
							}
						}
					}
				}else{ 
					$authArray = $this->getrow($this->query("SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "nuke":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				if(!empty($_REQUEST['user'])){ 
					$nukeUserID = explode(":",base64_decode($_REQUEST['user']));
					$nukeUserID = $nukeUserID[0];
					/*-Debugger-*/ $errors['User ID']['Mode'] = 'Nuke normal user';
					/*-Debugger-*/ $errors['User ID']['ID'] = $nukeUserID;
					
					$authArray = $this->getrow($this->query("SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}elseif(!empty($_REQUEST['admin'])){
					$nukeUserID = explode(":",base64_decode($_REQUEST['admin']));
					$nukeUserID = $nukeUserID[0];
					/*-Debugger-*/ $errors['User ID']['Mode'] = 'Nuke admin';
					/*-Debugger-*/ $errors['User ID']['ID'] = $nukeUserID;
					$authArray = $this->getrow($this->query("SELECT aid, name FROM ".$_SESSION['forumDBprefix']."authors WHERE aid = '".$nukeUserID."'", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT aid, name FROM ".$_SESSION['forumDBprefix']."authors WHERE aid = '".$nukeUserID."'";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "postnuke":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				$user = $this->getrow($this->query("SELECT session_info.pn_uid FROM ".$_SESSION['forumDBprefix']."session_info WHERE session_info.pn_sessid = '".$_REQUEST['POSTNUKESID']."'", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['User ID']['Query'] = "SELECT session_info.pn_uid FROM ".$_SESSION['forumDBprefix']."session_info WHERE session_info.pn_sessid = '".$_REQUEST['POSTNUKESID']."'";
				/*-Debugger-*/ $errors['User ID']['ID'] = $user['pn_uid'];
				if($user['pn_uid']) 
				{ 
					$authArray = $this->getrow($this->query("SELECT pn_uname, pn_name, pn_user_icq, pn_user_occ, pn_user_aim, pn_user_yim, pn_user_msnm FROM  ".$_SESSION['forumDBprefix']."users WHERE pn_uid = '".$user['pn_uid']."'", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT pn_uname, pn_name, pn_user_icq, pn_user_occ, pn_user_aim, pn_user_yim, pn_user_msnm FROM  ".$_SESSION['forumDBprefix']."users WHERE pn_uid = '".$user['pn_uid']."'";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "dragonfly":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				/*-Debugger-*/ if(!@in_array($_SESSION['opt_cookie_prefix'], $_REQUEST)) $errors['User ID']['Cause'] = '<b>Check the cookie name</b>';
				if(!empty($_REQUEST[$_SESSION['opt_cookie_prefix']])){ 
					$nukeUserID = explode(":",base64_decode($_REQUEST[$_SESSION['opt_cookie_prefix']]));
					$nukeUserID = $nukeUserID[0];
					/*-Debugger-*/ $errors['User ID']['ID'] = $nukeUserID;
					$authArray = $this->getrow($this->query("SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "vB":
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				$vBuserID = $this->getrow($this->query("SELECT userid FROM ".$_SESSION['forumDBprefix']."session WHERE sessionhash = '".$_REQUEST['wbsessionhash']."'", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['User ID']['Query'] = "SELECT userid FROM ".$_SESSION['forumDBprefix']."session WHERE sessionhash = '".$_REQUEST['wbsessionhash']."'";
				/*-Debugger-*/ $errors['User ID']['ID'] = $vBuserID['userid'];
				$authArray = $this->getrow($this->query("SELECT username, icq, aim, yahoo, msn FROM ".$_SESSION['forumDBprefix']."user WHERE userid = ".intval($vBuserID['userid'])."", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT username, icq, aim, yahoo, msn FROM ".$_SESSION['forumDBprefix']."user WHERE userid = ".intval($vBuserID['userid'])."";
				if($authArray){
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "tikiwiki":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."sessions.user FROM ".$_SESSION['forumDBprefix']."sessions WHERE ".$_SESSION['forumDBprefix']."sessions.sessionId = '".$_REQUEST['PHPSESSID']."'", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['User ID']['Query'] = "SELECT ".$_SESSION['forumDBprefix']."sessions.user FROM ".$_SESSION['forumDBprefix']."sessions WHERE ".$_SESSION['forumDBprefix']."sessions.sessionId = '".$_REQUEST['PHPSESSID']."'";
				/*-Debugger-*/ $errors['User ID']['ID'] = $authArray['user'];
				if($authArray['user']) 
				{
					if(!$this->checkRoster($authArray['user']))
					{
						$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."user_preferences.value FROM  ".$_SESSION['forumDBprefix']."user_preferences WHERE prefName = 'realName' AND user = '".$authArray['user']."'", $_SESSION['separateDB']));
						/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT ".$_SESSION['forumDBprefix']."user_preferences.value FROM  ".$_SESSION['forumDBprefix']."user_preferences WHERE prefName = 'realName' AND user = '".$authArray['user']."'";
						if($authArray['value'])
						{
							/*-Debugger-*/ $errors['Character Name'] = $authArray['value'];
							$this->checkRoster($authArray['value']);
						}
					}
				} # $userName = $user['user'];
				break;
			}
			case "smf":
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				/*-Debugger-*/ if(!@in_array($_SESSION['opt_cookie_prefix'], $_REQUEST)) $errors['User ID']['Cause'] = '<b>Check the cookie name</b>';
				if(!empty($_REQUEST[$_SESSION['opt_cookie_prefix']]))
				{
					$smfUserID = explode(":", $_REQUEST[$_SESSION['opt_cookie_prefix']]);
					$smfUserID = explode('"', stripslashes($smfUserID[5]));
					/*-Debugger-*/ $errors['User ID']['ID'] = $smfUserID[1];
					$authArray = $this->getrow($this->query("SELECT memberName, realName, personalText, ICQ, AIM, YIM, MSN FROM ".$_SESSION['forumDBprefix']."members WHERE ID_MEMBER = ".intval($smfUserID[1])."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT memberName, realName, personalText, ICQ, AIM, YIM, MSN FROM ".$_SESSION['forumDBprefix']."members WHERE ID_MEMBER = ".intval($smfUserID[1])."";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "wbb":
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				if(!empty($_REQUEST['wbb_userid']))	{
					$authArray = $this->getrow($this->query("SELECT username, icq, aim, yim, msn FROM ".$_SESSION['forumDBprefix']."users WHERE userid = ".$_REQUEST['wbb_userid']."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT username, icq, aim, yim, msn FROM ".$_SESSION['forumDBprefix']."users WHERE userid = ".$_REQUEST['wbb_userid']."";
					if($authArray){
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				}
				break;
			}
			case "IPB": 
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				$authArray = $this->getrow($this->query("SELECT sessions.member_id, sessions.member_name, member_extra.aim_name, member_extra.yahoo, member_extra.msnname FROM ".$_SESSION['forumDBprefix']."sessions AS sessions, ".$_SESSION['forumDBprefix']."member_extra AS member_extra, ".$_SESSION['forumDBprefix']."members AS members WHERE sessions.id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'session_id']."' AND sessions.member_id = members.id AND sessions.member_id = member_extra.id", $_SESSION['separateDB'])); 
				/*-Debugger-*/ if(!@in_array($_SESSION['opt_cookie_prefix'].'session_id', $_REQUEST)) $errors['User ID']['Cause'] = '<b>The cookie name seems to be the problem</b>';
				/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT sessions.member_id, sessions.member_name, member_extra.aim_name, member_extra.yahoo, member_extra.msnname FROM ".$_SESSION['forumDBprefix']."sessions AS sessions, ".$_SESSION['forumDBprefix']."member_extra AS member_extra, ".$_SESSION['forumDBprefix']."members AS members WHERE sessions.id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'session_id']."' AND sessions.member_id = members.id AND sessions.member_id = member_extra.id";
				if($authArray){
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			// Joomla mixes all session info, md5's it and then writes it into the cookie. 
			// I dont see a way to backtrack in order to get the userID or username from the cookie.
			/* 
			case "joomla":
			{
				if($_COOKIE['usercookie']['username']){
					if(!$this->checkRoster($_COOKIE['usercookie']['username']))
					{
						$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."users.name FROM  ".$_SESSION['forumDBprefix']."users WHERE ".$_SESSION['forumDBprefix']."users.username = '".$_COOKIE['usercookie']['username']."'", $_SESSION['separateDB']));
						if($authArray)
						{
							$this->checkRoster($authArray['user_'.$_SESSION['profileField']]);
						}
					}
				}# $userName = $_COOKIE['usercookie']['username'];
				break;
			} 
			*/
			case "unb":
			{
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				//$_SESSION['prog_id'] = 'unb472';	
				// In your unb board config section go to "Security" and read the "Program ID", that value has to be put in here.
				/*-Debugger-*/ if(!@in_array($_SESSION['prog_id'].'-CUserID', $_REQUEST)) $errors['User ID']['Cause'] = '<b>The prog id seems to be the problem</b>';
				/*-Debugger-*/ $errors['User ID']['Prog ID'] = $_SESSION['prog_id'];
				if($_COOKIE[$_SESSION['prog_id'].'-CUserID'])
				{
					$authArray = $this->getrow($this->query("SELECT name, JABBER, ICQ, AIM, YIM, MSN FROM ".$_SESSION['forumDBprefix']."users WHERE ID = ".$_COOKIE[$_SESSION['prog_id'].'-CUserID']."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT name, JABBER, ICQ, AIM, YIM, MSN FROM ".$_SESSION['forumDBprefix']."users WHERE ID = ".$_COOKIE[$_SESSION['prog_id'].'-CUserID']."";
					if($authArray)
					{
						foreach($authArray as $field => $name){
							/*-Debugger-*/ $errors['Character Name'][$field] = $name;
							if(!empty($name)) $this->checkRoster($name);
						}
					}
				}# $_COOKIE[$_SESSION['prog_id'].'-CUserID'];
				break;
			}
			case "phpfusion":
			{	
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				if ($_COOKIE['fusion_user']) {
					$cookie_vars = explode(".", $_COOKIE['fusion_user']);
					/*-Debugger-*/ $errors['User ID']['ID'] = $cookie_vars[0];
					$authArray = $this->getrow($this->query("SELECT user_name, user_aim, user_icq, user_msn, user_yahoo FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".intval($cookie_vars[0])."", $_SESSION['separateDB']));
					/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT user_name, user_aim, user_icq, user_msn, user_yahoo FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".intval($cookie_vars[0])."";
					foreach($authArray as $field => $name){
						/*-Debugger-*/ $errors['Character Name'][$field] = $name;
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "minibb":
			{// $cookiename='miniBBsite'; $cookiepath='/'; in setup_options.php
				/*-Debugger-*/ $errors['CMS']['Type'] = $CMStype;
				$miniBBcookie = explode("|", $_REQUEST['miniBBsite']);
				/*-Debugger-*/ $errors['User ID']['Cookie'] = $_REQUEST['miniBBsite'];
				$authArray = $this->getrow($this->query("SELECT username, user_icq FROM ".$_SESSION['forumDBprefix']."users WHERE username = '".$miniBBcookie[0]."'", $_SESSION['separateDB']));
				/*-Debugger-*/ $errors['CMS']['Query'] = "SELECT username, user_icq FROM ".$_SESSION['forumDBprefix']."users WHERE username = '".$miniBBcookie[0]."'";
				if($authArray){
					if(!$this->checkRoster($authArray['username'])){
						$this->checkRoster($authArray['user_icq']);
					}
				}
				break;
			}
		}

		if(!$_COOKIE['RosterUserName']){
			$_SESSION['UserName'] = ucfirst(strtolower($GLOBALS['rosterUserName']));
		} else {
			$_SESSION['UserName'] = $_COOKIE['RosterUserName'];
		}
		$_SESSION['errors'] = $errors;
	}
}
$Authentication = new Authentication();
$Authentication->getSettings();
$Authentication->detectCMS();

?>